# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['StateArgs', 'State']

@pulumi.input_type
class StateArgs:
    def __init__(__self__, *,
                 type: pulumi.Input[str],
                 description: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 initial: Optional[pulumi.Input[bool]] = None,
                 key: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a State resource.
        :param pulumi.Input[str] type: [StateType](https://docs.commercetools.com/api/projects/states#statetype)
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] description: Description of the State as localized string.
        :param pulumi.Input[bool] initial: A state can be declared as an initial state for any state machine. When a workflow starts, this first state must be an
               initial state
        :param pulumi.Input[str] key: Timestamp of the last Terraform update of the order.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] name: Name of the State as localized string.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] roles: [State Role](https://docs.commercetools.com/api/projects/states#staterole)
        """
        pulumi.set(__self__, "type", type)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if initial is not None:
            pulumi.set(__self__, "initial", initial)
        if key is not None:
            pulumi.set(__self__, "key", key)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if roles is not None:
            pulumi.set(__self__, "roles", roles)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        [StateType](https://docs.commercetools.com/api/projects/states#statetype)
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Description of the State as localized string.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def initial(self) -> Optional[pulumi.Input[bool]]:
        """
        A state can be declared as an initial state for any state machine. When a workflow starts, this first state must be an
        initial state
        """
        return pulumi.get(self, "initial")

    @initial.setter
    def initial(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "initial", value)

    @property
    @pulumi.getter
    def key(self) -> Optional[pulumi.Input[str]]:
        """
        Timestamp of the last Terraform update of the order.
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Name of the State as localized string.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def roles(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        [State Role](https://docs.commercetools.com/api/projects/states#staterole)
        """
        return pulumi.get(self, "roles")

    @roles.setter
    def roles(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "roles", value)


@pulumi.input_type
class _StateState:
    def __init__(__self__, *,
                 description: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 initial: Optional[pulumi.Input[bool]] = None,
                 key: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 version: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering State resources.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] description: Description of the State as localized string.
        :param pulumi.Input[bool] initial: A state can be declared as an initial state for any state machine. When a workflow starts, this first state must be an
               initial state
        :param pulumi.Input[str] key: Timestamp of the last Terraform update of the order.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] name: Name of the State as localized string.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] roles: [State Role](https://docs.commercetools.com/api/projects/states#staterole)
        :param pulumi.Input[str] type: [StateType](https://docs.commercetools.com/api/projects/states#statetype)
        """
        if description is not None:
            pulumi.set(__self__, "description", description)
        if initial is not None:
            pulumi.set(__self__, "initial", initial)
        if key is not None:
            pulumi.set(__self__, "key", key)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if roles is not None:
            pulumi.set(__self__, "roles", roles)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Description of the State as localized string.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def initial(self) -> Optional[pulumi.Input[bool]]:
        """
        A state can be declared as an initial state for any state machine. When a workflow starts, this first state must be an
        initial state
        """
        return pulumi.get(self, "initial")

    @initial.setter
    def initial(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "initial", value)

    @property
    @pulumi.getter
    def key(self) -> Optional[pulumi.Input[str]]:
        """
        Timestamp of the last Terraform update of the order.
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Name of the State as localized string.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def roles(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        [State Role](https://docs.commercetools.com/api/projects/states#staterole)
        """
        return pulumi.get(self, "roles")

    @roles.setter
    def roles(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "roles", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        [StateType](https://docs.commercetools.com/api/projects/states#statetype)
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "version", value)


class State(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 initial: Optional[pulumi.Input[bool]] = None,
                 key: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a State resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] description: Description of the State as localized string.
        :param pulumi.Input[bool] initial: A state can be declared as an initial state for any state machine. When a workflow starts, this first state must be an
               initial state
        :param pulumi.Input[str] key: Timestamp of the last Terraform update of the order.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] name: Name of the State as localized string.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] roles: [State Role](https://docs.commercetools.com/api/projects/states#staterole)
        :param pulumi.Input[str] type: [StateType](https://docs.commercetools.com/api/projects/states#statetype)
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: StateArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a State resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param StateArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(StateArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 initial: Optional[pulumi.Input[bool]] = None,
                 key: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = StateArgs.__new__(StateArgs)

            __props__.__dict__["description"] = description
            __props__.__dict__["initial"] = initial
            __props__.__dict__["key"] = key
            __props__.__dict__["name"] = name
            __props__.__dict__["roles"] = roles
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__.__dict__["type"] = type
            __props__.__dict__["version"] = None
        super(State, __self__).__init__(
            'commercetools:index/state:State',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            description: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            initial: Optional[pulumi.Input[bool]] = None,
            key: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            type: Optional[pulumi.Input[str]] = None,
            version: Optional[pulumi.Input[int]] = None) -> 'State':
        """
        Get an existing State resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] description: Description of the State as localized string.
        :param pulumi.Input[bool] initial: A state can be declared as an initial state for any state machine. When a workflow starts, this first state must be an
               initial state
        :param pulumi.Input[str] key: Timestamp of the last Terraform update of the order.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] name: Name of the State as localized string.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] roles: [State Role](https://docs.commercetools.com/api/projects/states#staterole)
        :param pulumi.Input[str] type: [StateType](https://docs.commercetools.com/api/projects/states#statetype)
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _StateState.__new__(_StateState)

        __props__.__dict__["description"] = description
        __props__.__dict__["initial"] = initial
        __props__.__dict__["key"] = key
        __props__.__dict__["name"] = name
        __props__.__dict__["roles"] = roles
        __props__.__dict__["type"] = type
        __props__.__dict__["version"] = version
        return State(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Description of the State as localized string.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def initial(self) -> pulumi.Output[bool]:
        """
        A state can be declared as an initial state for any state machine. When a workflow starts, this first state must be an
        initial state
        """
        return pulumi.get(self, "initial")

    @property
    @pulumi.getter
    def key(self) -> pulumi.Output[Optional[str]]:
        """
        Timestamp of the last Terraform update of the order.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[Mapping[str, str]]:
        """
        Name of the State as localized string.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def roles(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        [State Role](https://docs.commercetools.com/api/projects/states#staterole)
        """
        return pulumi.get(self, "roles")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        [StateType](https://docs.commercetools.com/api/projects/states#statetype)
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[int]:
        return pulumi.get(self, "version")

